<?php   
    Header("Cache-Control: no-cache");
    Header("Pragma: no-cache");
    Header("Expires: Sat, Jan 01 2000 01:01:01 GMT");

    include("global.inc");


    // Do this only once
    $dnsbl_check = explode(":", SPAM_BLACKLISTS);
    $blacklist = array();

function is_blacklisted($ip)
{
    global $dnsbl_check;
    global $blacklist;

    /* $blacklist[$ip] is set to FALSE if $ip is found OK before. This
       will handle multiple emails from the same source much faster. */
    if (isset($blacklist[$ip]))
    {
        return $blacklist[$ip];
    }

    $listed = FALSE;
    if ($ip)
    {
        $quads = explode(".", $ip);
        $rip = $quads[3] . "." . $quads[2] . "." . $quads[1] . "." . $quads[0];
        for ($i=0; $i < count($dnsbl_check); $i++) 
        {
            if (checkdnsrr($rip . "." . $dnsbl_check[$i], "A")) 
            {
                $listed = $dnsbl_check[$i];
                break;
            }
        }
        /* cache results, as $listed or FALSE */
        $blacklist[$ip] = $listed;
        return $listed;
    }
}

function content()
{

    content_start();
?>
<script type="text/javascript">
<!--
function checkchecked()
{
    flag = false;
    for(i=0 ; i<document.delmov.elements.length; i++)
    {
        if(document.delmov.elements[i].type == "checkbox")
        {
            if(document.delmov.elements[i].checked)
            {
                flag = true;
            }
        }
    }
    if(!flag)
    {
        alert("<?php echo L_SELECT_ERROR ?>");
        document.delmov.tofolder.selectedIndex = 0;
    }
    return flag;
}

function doSubmit()
{
    if (checkchecked()) 
    {
        document.delmov.move.value = 1;
        document.delmov.submit();
    }
}

var newcheckstate = true;

function check_all()
{

    for(i=0 ; i<document.delmov.elements.length; i++)
    {
        if(document.delmov.elements[i].type == "checkbox")
        {
            document.delmov.elements[i].checked = newcheckstate;
        }
    }
    newcheckstate = !newcheckstate;
}
//-->
</script>
<?php
    header_start();
    
    global $folder;
    global $mailbox;
    global $start, $count;
    global $sort;

    header_left();
    global $user;
    echo "$folder - $user - " . PROG_NAME . " - ";

    $issentmail = (($folder == SENT_MAIL) && is_string(SENT_MAIL));
    $numcols = 6;
    if ($issentmail)
        $numcols--;

    if ($sort=="")
    {
        if ($issentmail)
            $sort = 100 + SORTDATE;
        else
            $sort = 100 + SORTARRIVAL;
    }

    $nummsg = imap_num_msg($mailbox);
    if ($nummsg > 0)
    {
        $s = $sort;
        $r = 0;
        if ($s > 99)
        {
            $s -= 100;
            $r = 1;
        }
        
        $msg_array = imap_sort($mailbox, $s, $r);
        echo "$nummsg";
    }
    else
    {
        echo "$nummsg";
    }

    $out = " " . ($nummsg == 1 ? L_MESSAGE : L_MESSAGES);
    echo $out;
    header_left_right_end();

    // code to display start to count

    $msg_start = $start ? $start : 1;
    $msg_start--;
    $tmp_count = $count ? $count : MSG_COUNT;
    $tmp_display = $tmp_count > $nummsg ? $nummsg : $tmp_count;
    $nummsg_display = $tmp_display > ($nummsg - $msg_start) ? ($nummsg - $msg_start) : $tmp_display;
?>

<?php

    if (USE_FOLDERS) {
        header_right();
?>
        <form name="switchbox" action="index.php" method="GET">
        <select name=folder onChange="submit()">
        <option value=""><?php echo L_FOLDER_SWITCH ?>:
        <?php list_folders($mailbox); ?>
        </select>
        <noscript>
        <input type="submit" value="<?php echo L_SUBMIT_BTN ?>">
        </noscript>
        </form>
<?php
        header_left_right_end();
        header_right();
        echo "&nbsp;&nbsp;&nbsp;";
        header_left_right_end();
        header_right();
?>
        <form action="folder.php">
        <input type="hidden" name="folder" value="<?php echo $folder ?>">
        <input type="submit" value="<?php echo L_FOLDER_BTN ?>">
        </form>
<?php 
        header_left_right_end();
    }
    header_right();
?>
        <form action="logout.php" method="get">
        <input type="submit" value="<?php echo L_LOGOUT_BTN ?>">
        </form>
<?php
    header_left_right_end();
    header_end();
    body_start();
    title_start();
    title_left();
?>

    <form name="delmov" action="action.php" method="GET" onsubmit="return checkchecked()">
    <input type="hidden" name="folder" value="<?php echo "$folder" ?>">
<?php
    global $HTTP_SERVER_VARS;
?>
    <a href="<?php echo htmlspecialchars($HTTP_SERVER_VARS["REQUEST_URI"]) ?>"><img src="images/refresh.gif" alt="@" border="0" height="16" width="21"></a>
<?php 
    title_left_end();
    title_left();
    global $sort;
    echo "<a href=\"";
    if ($sort == SORTSUBJECT)
        $s = 100 + SORTSUBJECT;
    else
        $s = SORTSUBJECT;
    echo self_with_param("sort", $s);
    echo "\">";
    echo L_SUBJECT_HDR;
    echo "&nbsp;";
    if ($sort == SORTSUBJECT)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTSUBJECT)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    echo "</a>";
    title_left_end();
    if (!$issentmail)
    {
        title_left();
        echo "<a href=\"";
        if ($sort == SORTFROM)
            $s = 100 + SORTFROM;
        else
            $s = SORTFROM;
        echo self_with_param("sort", $s);
        echo "\">";
        echo L_FROM_HDR;
        echo "&nbsp;";
        if ($sort == SORTFROM)
            echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
        if ($sort == 100 + SORTFROM)
            echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
        title_left_end();
    }
    title_left();
    echo "<a href=\"";
    if ($sort == SORTTO)
        $s = 100 + SORTTO;
    else
        $s = SORTTO;
    echo self_with_param("sort", $s);
    echo "\">";
    echo L_TO_HDR;
    echo "&nbsp;";
    if ($sort == SORTTO)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTTO)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    title_left_end();
    title_left();
    echo "<a href=\"";
    if ($issentmail)
    {
        if ($sort == SORTDATE)
            $s = 100 + SORTDATE;
        else
            $s = SORTDATE;
    }
    else
    {
        if ($sort == SORTARRIVAL)
            $s = 100 + SORTARRIVAL;
        else
            $s = SORTARRIVAL;
    }
    echo self_with_param("sort", $s);
    echo "\">";
    echo $issentmail ? L_SENT_HDR : L_RECEIVED_HDR;
    echo "&nbsp;";
    if ($issentmail)
    {
        if ($sort == SORTDATE)
            echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
        if ($sort == 100 + SORTDATE)
            echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    }
    else
    {
        if ($sort == SORTARRIVAL)
            echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
        if ($sort == 100 + SORTARRIVAL)
            echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    }
    title_left_end();
    title_left();
    echo "<a href=\"";
    if ($sort == SORTSIZE)
        $s = 100 + SORTSIZE;
    else
        $s = SORTSIZE;
    echo self_with_param("sort", $s);
    echo "\">";
    echo L_SIZE_HDR;
    echo "&nbsp;";
    if ($sort == SORTSIZE)
        echo "<img src=\"images/ascending.gif\" alt=\"^\" width=\"8\" height=\"8\" border=\"0\">";
    if ($sort == 100 + SORTSIZE)
        echo "<img src=\"images/descending.gif\" alt=\"v\" width=\"8\" height=\"8\" border=\"0\">";
    echo "</a>";
    title_left_end();
    title_end();

    if($nummsg == 0)
    {
        body_row('class="rowon"');
        body_left('colspan="' . $numcols . '"');
        echo L_FOLDER_EMPTY;
        body_left_end();
        body_row_end();
    }

    $flipflop = 0;
    global $select;

    for( $i=$msg_start ; $i < $msg_start + $nummsg_display ; $i++ )
    {

        $struct = imap_fetchstructure($mailbox, $msg_array[$i]);
        $attach = "&nbsp;";

        for($j = 0; $j < count($struct->parts); $j++)
        {
            if(!$struct->parts[$j]) {
                $part = $struct;
            }
            else {
                $part = $struct->parts[$j];
            }

            $att_name = get_att_name($part);
            if ($att_name != "Unknown")
            {
                $attach = "&nbsp;@";
            }
        }


        $msg = imap_header($mailbox, $msg_array[$i]);

        $subject = !$msg->Subject ? L_NO_SUBJECT : $msg->Subject;
        //@@@$subject = htmlspecialchars(decode_header_string($subject));
        $subject = decode_header_string($subject);
        

        $ksize = round(10*($msg->Size/1000))/10;
        $size = $msg->Size > 1000 ? "$ksize k" : $msg->Size;

        if($flipflop == 0)
        {
            $bg = "rowon";
            $flipflop = 1;
        }
        else
        {
            $bg = "rowoff";
            $flipflop = 0;
        }

        body_row('class="' . $bg . '"');
        body_left();
        /* Check for spam */
        $possible_spam = 0;
        if (SPAM_BLACKLISTS)
        {
            /* Make sure it keeps on moving! */
            flush();
            $rawheaders = imap_fetchbody($mailbox, $msg_array[$i], 0);
            $headers = explode("Received: ", $rawheaders);
            for ($h = 0; $h < count($headers); $h++)
            {
                if (ereg("^from ([^ ]* )?\(([^ ]* )?\[([0-9\.]*)\]", $headers[$h], $regs))
                {
                    $fromip = $regs[3];
                    $ret = is_blacklisted($fromip);
                    if ($ret)
                    {
                        $possible_spam = 1;
                        break;
                    }
                }
            }
        }
        
        echo "<input type=\"checkbox\" name=\"msglist[]\" value=\"$msg_array[$i]\"";
        if ($select=="all")
            echo " checked=\"checked\"";
        if (/*$select=="spam" &&*/ $possible_spam)
            echo " checked=\"checked\"";
        echo ">";
        body_left_end();
        body_left();
        if ($possible_spam)
            print "<font color=\"red\">***SPAM*** </font>";
        echo "<a href=\"message.php?folder=" . urlencode($folder) . "&amp;msgnum=$msg_array[$i]\">";
        echo make_utf8($subject, get_charset($struct));
        echo "</a>$attach\n";
        if ($possible_spam)
            print "<br><font color=\"red\"><small>($ret)</small></font>";
        body_left_end();
        if(!$issentmail)
        {
            body_left();
            if($msg->from)
                echo make_clickable_list($msg->from, $folder);
            else
                echo L_NO_FROM;
            body_left_end();
        }
        body_left();
        if ($msg->to)
            echo make_clickable_list($msg->to, $folder);
        else
            echo L_NO_TO;
        body_left_end();
        body_left();
        echo date(L_DATE_FORMAT, $msg->udate);
        body_left_end();
        body_left();
        echo "$size\n";
        body_left_end();
        body_row_end();
    }
    title_start();
    title_left();
?>
<script type="text/javascript">
    document.write('<a href="javascript:check_all()"><img src="images/check.gif" alt="V" border="0" height="16" width="21"></a>');
</script>
<noscript>
<?php

    if ($select!="all")
        $url = self_with_param("select", "all");
    else
        $url = self_with_param("select", "");
    echo "<a href=\"$url\"><img src=\"images/check.gif\" alt=\"V\" border=\"0\" height=\"16\" width=\"21\"></a>";
?>
</noscript>
<?php
    /*
    if (SPAM_BLACKLISTS)
    {
        if ($select!="spam")
        {
            $url = self_with_param("select", "spam");
            echo "<br><a href=\"$url\">spam</a>";
        }
    }
    */
    title_left_end();
    $colsleft = $numcols-1;
    title_left('colspan="' . $colsleft . '"');

    $location = $msg_start + 1;

    for($k=1; $k <= $nummsg; $k += $tmp_count)
    {
        $end_tmp = $k + $tmp_count - 1;
        $end = $end_tmp >= $nummsg ? $nummsg : $end_tmp;

        $newlink = "<a class=\"msg\" href=\"index.php?folder=$folder&amp;sort=$sort&amp;start=$k&amp;count=$tmp_count\">";
        $link = (($k <= $location) and ($location <= $end)) ?  "" : $newlink;
        echo $link . "[$k-" . $end;
        $link = (($k <= $location) and ($location <= $end)) ?  "" : "</a>";
        echo "]" . $link;

        echo "&nbsp;&nbsp; ";
    }
    title_left_end();
    title_end();
    body_end();

    header_start();
    header_left();
    if (USE_FOLDERS) {
?>        
        <select name="tofolder" onChange="doSubmit()">
        <option><?php echo L_FOLDER_MOVE ?>:
        <?php list_folders($mailbox); ?>
        </select>
        <script type="text/javascript">
        <!--
            // A var named 'move' must always exist.
            document.write('<input type="hidden" name="move" value="">');
        //-->
        </script>
        <noscript>
            <input type="submit" name="move" value="<?php echo L_SUBMIT_BTN ?>">
        </noscript>
<?php
    }
    echo "&nbsp;";
    header_left_right_end();
    header_right();
?>
        <input type="submit" name="delall" value="<?php echo L_DELETE_BTN ?>">
    </form>
<?php
    header_left_right_end();
    header_right();
?>
        <form action="compose.php" method="get">
        <input type="hidden" name="folder" value="<?php echo $folder ?>">
        <input type="submit" value="<?php echo L_COMPOSE_BTN ?>">
        </form>
<?php
    header_left_right_end();
    header_end();
    content_end();
    imap_close($mailbox); 
}

/* MAIN */
include(HTML_TEMPLATE);

?>
